Index: issm/trunk-jpl/test/Par/RoundSheetShelf.py
===================================================================
--- issm/trunk-jpl/test/Par/RoundSheetShelf.py	(revision 20992)
+++ issm/trunk-jpl/test/Par/RoundSheetShelf.py	(revision 21409)
@@ -14,5 +14,5 @@
 hmin=300.
 hmax=1000.
-radius=numpy.sqrt(md.mesh.x.reshape(-1,1)*md.mesh.x.reshape(-1,1)+md.mesh.y.reshape(-1,1)*md.mesh.y.reshape(-1,1))
+radius=numpy.sqrt(md.mesh.x*md.mesh.x+md.mesh.y*md.mesh.y.reshape(-1))
 ymin=numpy.min(radius)
 ymax=numpy.max(radius)
@@ -58,26 +58,26 @@
 
 #Initial velocity 
-md.initialization.vx=numpy.zeros((md.mesh.numberofvertices,1))
-md.initialization.vy=numpy.zeros((md.mesh.numberofvertices,1))
-md.initialization.vz=numpy.zeros((md.mesh.numberofvertices,1))
-md.initialization.pressure=numpy.zeros((md.mesh.numberofvertices,1))
+md.initialization.vx=numpy.zeros((md.mesh.numberofvertices))
+md.initialization.vy=numpy.zeros((md.mesh.numberofvertices))
+md.initialization.vz=numpy.zeros((md.mesh.numberofvertices))
+md.initialization.pressure=numpy.zeros((md.mesh.numberofvertices))
 
 #Materials
-md.initialization.temperature=(273.-20.)*numpy.ones((md.mesh.numberofvertices,1))
+md.initialization.temperature=(273.-20.)*numpy.ones((md.mesh.numberofvertices))
 md.materials.rheology_B=paterson(md.initialization.temperature)
-md.materials.rheology_n=3.*numpy.ones((md.mesh.numberofelements,1))
+md.materials.rheology_n=3.*numpy.ones((md.mesh.numberofelements))
 
 #Surface mass balance and basal melting
-md.smb.mass_balance=-10.*numpy.ones((md.mesh.numberofvertices,1))
-md.basalforcings.groundedice_melting_rate=numpy.zeros((md.mesh.numberofvertices,1))
+md.smb.mass_balance=-10.*numpy.ones((md.mesh.numberofvertices))
+md.basalforcings.groundedice_melting_rate=numpy.zeros((md.mesh.numberofvertices))
 pos=numpy.nonzero(md.mask.groundedice_levelset>0.)[0]
 md.basalforcings.groundedice_melting_rate[pos]=10.
-md.basalforcings.floatingice_melting_rate=numpy.zeros((md.mesh.numberofvertices,1))
-md.basalforcings.geothermalflux=numpy.ones((md.mesh.numberofvertices,1))
+md.basalforcings.floatingice_melting_rate=numpy.zeros((md.mesh.numberofvertices))
+md.basalforcings.geothermalflux=numpy.ones((md.mesh.numberofvertices))
 
 #Friction
 radius=1.e6
 shelfextent=2.e5
-md.friction.coefficient=20.*numpy.ones((md.mesh.numberofvertices,1))
+md.friction.coefficient=20.*numpy.ones((md.mesh.numberofvertices))
 xelem=numpy.mean(md.mesh.x[md.mesh.elements.astype(int)-1],axis=1)
 yelem=numpy.mean(md.mesh.y[md.mesh.elements.astype(int)-1],axis=1)
@@ -86,6 +86,6 @@
 pos=numpy.nonzero(rad>=(radius-shelfextent))
 md.friction.coefficient[md.mesh.elements[pos,:]-1]=0.
-md.friction.p=numpy.ones((md.mesh.numberofelements,1))
-md.friction.q=numpy.ones((md.mesh.numberofelements,1))
+md.friction.p=numpy.ones((md.mesh.numberofelements))
+md.friction.q=numpy.ones((md.mesh.numberofelements))
 
 #Numerical parameters
@@ -109,7 +109,7 @@
 
 #Deal with boundary conditions:
-md.stressbalance.spcvx=float('nan')*numpy.ones((md.mesh.numberofvertices,1))
-md.stressbalance.spcvy=float('nan')*numpy.ones((md.mesh.numberofvertices,1))
-md.stressbalance.spcvz=float('nan')*numpy.ones((md.mesh.numberofvertices,1))
+md.stressbalance.spcvx=float('nan')*numpy.ones((md.mesh.numberofvertices))
+md.stressbalance.spcvy=float('nan')*numpy.ones((md.mesh.numberofvertices))
+md.stressbalance.spcvz=float('nan')*numpy.ones((md.mesh.numberofvertices))
 
 pos=numpy.nonzero(numpy.logical_and(md.mesh.x==0,md.mesh.y==0))
@@ -119,9 +119,9 @@
 pos=numpy.nonzero(md.mesh.vertexonboundary)
 md.mask.ice_levelset[pos]=0
-md.balancethickness.spcthickness=float('nan')*numpy.ones((md.mesh.numberofvertices,1))
-md.masstransport.spcthickness=float('nan')*numpy.ones((md.mesh.numberofvertices,1))
+md.balancethickness.spcthickness=float('nan')*numpy.ones((md.mesh.numberofvertices))
+md.masstransport.spcthickness=float('nan')*numpy.ones((md.mesh.numberofvertices))
 md.stressbalance.referential=float('nan')*numpy.ones((md.mesh.numberofvertices,6))
 md.stressbalance.loadingforce=0*numpy.ones((md.mesh.numberofvertices,3))
-md.thermal.spctemperature=737.*numpy.ones((md.mesh.numberofvertices,1))
+md.thermal.spctemperature=737.*numpy.ones((md.mesh.numberofvertices))
 
 #Change name so that no test have the same name